Subject: Re: Detecting router id change in p2p-over-lan connection

From: Sunil Patro <[email-masked]>
Date: Fri, 17 Feb 2006 20:29:45 -0800

Mitchell,

I guess we can compare the IP src address of the neighbor to find out if

the new router-id is coming from the same neighbor or a different
neighbor.

Btw, I am unclear about your reference to L1 and L2 needing separate
hellos.

Quoting your last line - 
" Normally if one changes a router-id, then they don't expect that
  the former/old adjacency will be used with the new router-id."

I am guessing  you mean that anytime there is a router-id change in the
neighbor, the neighboring router should tear down the adjacency by
sending appropriate hello with the old router-id (by not including our
router id in the neighbor list) and then sending a new hello with a new
router-id.

In any case, can we say that section 4.5 is unclear about handling
router-id change? And it is left to the implementor to find the best way
to handle the router-id change?

Thanks,
Sunil

> -----Original Message-----
> From: Mailing List [mailto:[email-masked]] On Behalf Of
> Erblichs
> Sent: Friday, February 17, 2006 8:09 PM
> To: [email-masked]
> Subject: Re: Detecting router id change in p2p-over-lan connection
> 
> 	Not reading the draft. :^)
> 
>         The 4.5 section only deals with matching hello types
>         and circuit types for established adjacencies. The section
>         does not include that L1 AND L2 need separate hellos.
> 
>         Their is no mention about changing router-ids. However,
>         if I remember my IS-IS correctly, (yes, I have also coded
>         for the IS-IS / ES-ISL3 protocol) then the MAC value
>         would be the same even with a different system-id. There
>         is a presumed single MAC per interface per router versus
>         normally a single MAC value for an entire host system.
> 
>         The same would be true for OSPF, that the interface
>         should have the same MAC value even though the router-id
>         might have changed. However this does not hold true
>         if a vendor has also switched interfaces or circuits
>         that is forming the adj as these other interfaces would
>         have a different MAC value.
> 
>         Thus, you can tell if a router has changed router-ids.
>         However, this still presumes that you have kept dead
>         nbrs/peers history and that you have made a check against
>         matching died nbr/peers.
> 
>         Normally if one changes a router-id, then they don't expect
that
>         the former/old adjacency will be used with the new router-id.
> 
>         Mitchell Erblich
>         -------------
> 
> Sunil Patro wrote:
> >
> > The same draft talks about ospf in sec 4.2.
> > I guess they don't have a draft named separately for ospf.
> >
> > Thanks,
> > Sunil
> >
> > > -----Original Message-----
> > > From: Mailing List [mailto:[email-masked]] On Behalf Of
> > > Erblichs
> > > Sent: Friday, February 17, 2006 7:41 PM
> > > To: [email-masked]
> > > Subject: Re: Detecting router id change in p2p-over-lan connection
> > >
> > > Sunil,
> > >
> > >       The doc that you refer to is a IS-IS RFC draft and
> > >       you sent the question to a OSPF mail alias?
> > >
> > >       Mitchell Erblich
> > >       --------------------
> > >
> > > Sunil Patro wrote:
> > > >
> > > > Hi everyone,
> > > >
> > > > According to section 4.5 in draft
draft-ietf-isis-igp-p2p-over-lan-
> > > 05.txt,
> > > >
> > > >    "If the circuit is configured as point-to-point type and
receives
> > > >    LAN hello packets, the router MUST discard the incoming
packets;
> > If
> > > >    the circuit is a LAN type and receive point-to-point hello
> > packets,
> > > >    it MUST discard the incoming packets. If the system ID or the
> > > >    router ID of incoming hello packet does not match the system
ID
> > or
> > > >    the router ID of already established adjacency over this
> > p2p-over-lan
> > > >    circuit, it MUST discard the packet. The implementation
should
> > offer
> > > >    logging and debugging information of the above events.",
> > > >
> > > > My question is how does one detect a router-id change in this
> > scenario
> > > then?
> > > >
> > > > thanks,
> > > > Sunil

---

From: Acee Lindem <[email-masked]>
Date: Mon, 20 Feb 2006 09:28:28 -0500

Hi Sunil, Nitin, and Mitchell,

As Dave points out, a point-to-point network is explicitly defined as a 
connection between
a single pair of routers. Also, RFC 2328 dictates that router-id be used 
to identify neighbors
on point-to-point links. Hence, what 
draft-ietf-isis-igp-p2p-over-lan-05.txt is recommending
is to take the path of least resistance and handle router-id changes by 
letting the current
adjacency time out before forming a new one. Another option for 
point-to-point links would
be to force the neighbor down when a router-id change is detected. If 
you do something
more clever like using the source address as a hint to determine if the 
router-id has changed
or maintaining more than one adjacency, there is no guarantee that other 
implementations will
do the same.

IMHO, we shouldn't try and optimize for the router-id change case nor 
should we try
and specify precisely how implementations should handle router-id 
changes at this point
in the OSPF protocol evolution. I'll discuss this with the authors of
draft-ietf-isis-igp-p2p-over-lan-05.txt.

Thanks,
Acee